#ifndef _S_FGETL_F_
#define _S_FGETL_F_
/*
  ǂݍ1s̒ɏ̖fgets	Ver.1.06d
  malloczŕԂ̂ŁAĂяoōŌfree()邱
  
  Ver.1.00 Ƃ肠쐬
  Ver.1.01 obt@ǂݍ݌`ɕύX
  Ver.1.02 CR/LFΉɕύX
  Ver.1.03 stdin̎ɓs߁As_fgetloǉ
  Ver.1.04 stdin̎CR/LF_Ŕf悤ɂ(MS-DOS肠?)
  Ver.1.05 ungetcMS-DOSł͂܂@\ĂȂ̂łŎ
  Ver.1.06 ungetcfpɕʁXɋ@\悤P
*/
#include <string.h>
#include "s_malloc.h"
#include "s_xachar.h"

/* xɓǂݍޕ + 1 */
#define S_FGETL_STEP 1024

typedef struct _getc_list {
  FILE *fp;
  int   last_getc;
  struct _getc_list *next;
} getc_list;

static getc_list *s_gl = NULL;

#define init_fgetc(fp)	clean_fgetl(fp)
static void clean_fgetl(FILE *fp)
{
  getc_list *s,*gl;
  
  gl = s_gl;
  while(gl != NULL)
    {
      if(gl->fp == fp)
	{
	  if(s_gl == gl) s_gl = gl->next;
	  else
	    {
	      s = s_gl;
	      while(s->next != gl)
		{
		  s = s->next;
		}
	      s->next = gl->next;
	    }
	  free(gl);
	  gl = NULL;
	}
      if(gl != NULL) gl = gl->next;
    }
  return;
}

static int s_fgetc(FILE *fp)
{
  int c;
  getc_list *gl;
  
  c = -1;
  gl = s_gl;
  while(gl != NULL)
    {
      if(gl->fp == fp)
	{
	  c = gl->last_getc;
#if 0
	  printf("Debug : fgetc char '%c'\n",c);
#endif
	  clean_fgetl(fp);
	  gl = NULL;
	}
      if(gl != NULL) gl = gl->next;
    }
  if(c == -1) c = fgetc(fp);
  return(c);
}

#define s_ungetc(c,fp) s_unfgetc(c,fp)
static void s_unfgetc(int c,FILE *fp)
{
  getc_list *gl;
  
  if(c == EOF) return;
  gl = s_gl;
  while(gl != NULL)
    {
      if(gl->fp == fp)
	{
	  break;
	}
      gl = gl->next;
    }
#if 0
  printf("Debug : ungetc char '%c'\n",c);
#endif
  if(gl == NULL)
    {
#if 0
      printf("Debug : new fp\n");
#endif
      gl = xalloc(getc_list,1);
      gl->fp = fp;
      gl->last_getc = -1;
      gl->next = s_gl;
      s_gl = gl;
    }
  gl->last_getc = c;
}

static char *s_fgetl(FILE *fp)
{
  char *ret_code;
  char *d,*dd;
  int c,len,max_len;
  int daflag;
  
  len = 0;
  daflag = 0;
  max_len = S_FGETL_STEP;
  dd = NULL;
  while(max_len != 0)
    {
      len = max_len - 1;
      d = xalloc(char,max_len);
      if(dd != NULL)
	{
	  strcpy(d,dd);
	  free(dd);
	  dd = d;
	  d = strchr(dd,'\0');
	  len = len - (int)strlen(dd);
	}
      else
	{
	  dd = d;
	}
      while(len > 0)
	{
	  c = s_fgetc(fp);
	  switch(c)
	    {
	    case EOF:
	      len = -100;
	      break;
	    case 0x0d:
	      if(daflag != c)
		{
		  if(fp != stdin)
		    {
		      c = s_fgetc(fp);
		      if(c != 0x0a) s_ungetc(c,fp);
		    }
		}
	      daflag = 0x0a;
	      len = -1;
	      break;
	    case 0x0a:
	      if(daflag != c)
		{
		  if(fp != stdin)
		    {
		      c = s_fgetc(fp);
		      if(c != 0x0d) s_ungetc(c,fp);
		    }
		}
	      daflag = 0x0d;
	      len = -1;
	      break;
	    default:
	      daflag = 0;
	      *d = c;
	      d++;
	      len--;
	      break;
	    }
	}
      *d = '\0';
      switch(len)
	{
	case 0: /* obt@^ */
	  max_len += S_FGETL_STEP;
	  break;
	case -1: /* sR[hǂݍ */
	  max_len = 0;
	  break;
	case -100: /* ǂݍݏI(G[) */
	  max_len = 0;
	  if(d == dd)
	    {
	      free(dd);
	      dd = NULL;
	    }
	  break;
	}
    }
  ret_code = NULL;
  if(dd != NULL)
    {
      ret_code = xalloc_char(dd);
      free(dd);
    }
#if 0
  fprintf(stderr,"Debug : %s\n",ret_code);
#endif
  return(ret_code);
}
#endif
