#ifndef _S_FOPEN_F_
#define _S_FOPEN_F_

/*
  s_fopen Ver.1.03b

  Ver.1.00 Ƃ肠쐬
  Ver.1.01 filename == NULL ɂΉ(Istdin,stdout)
  Ver.1.02 openoȂ̃G[\Ή(s_fopen_chk)
  Ver.1.03 fp == NULL ɑΉ(s_fclose)
*/

#include "s_value.h"

static FILE *s_fopen(char filename[],char type[])
{
  int flag;
  FILE *fp;
  
  fp = NULL;
  flag = FALSE;
  if(filename == NULL) flag = TRUE;
  else
    {
      if((filename[0] == '-') && (filename[1] == '\0')) flag = TRUE;
    }
  if(flag)
    {
      switch(type[0])
	{
	case 'r': fp = stdin;  break;
	case 'w': fp = stdout; break;
	default:
	  fputs("s_fopen : Unknown type.\n",stderr);
	}
    }
  else
    {
      fp = fopen(filename,type);
    }
  return(fp);
}

static FILE *s_fopen_chk(char filename[],char type[])
{
  FILE *fp;
  fp = s_fopen(filename,type);
  if(fp == NULL)
    {
      fprintf(stderr,"Can't open file '%s' mode '%s'\n",filename,type);
      exit(2);
    }
  return(fp);
}

static int s_fclose(FILE *fp)
{
  int ret_code;
  ret_code = 0;
  if((fp != NULL)&&(fp != stdin)&&(fp != stdout)) ret_code = fclose(fp);
  return(ret_code);
}
#endif
