#ifndef _BASENAME_F_
#define _BASENAME_F_
/*
  basename.f Ver.1.02
  t@C̐؂o

  v s_malloc
  Ver.1.00 Ƃ肠쐬
  Ver.1.01 base_namefBNg܂ޕɕύX
  Ver.1.02 gqw肷Ɋ֐̎dlύXB

@ۑFa.tar.gz ̎Auav݂̂oׂAua.tarvƂׂB

  ʏgp`
  basename   = get_base_name("/usr/local/bin/test.tst/aaa.cnf",1);

  basename == "/usr/local/bin/test.tst/aaa"
*/
/*
  ʒ`
  _WINDOWS,_CONSOLE	Windowsp
  __MSDOS__		MSDOSp
  			unxiėp(FreeBSDp)
*/
#include "s_value.h"
#include "s_malloc.h"
#include <string.h>

#if defined(_WINDOWS) || defined(_CONSOLE)
#define __WINDOWS__
#endif

/* t@C̍ő咷 MAXPATHLEN` */
#ifndef		MAXPATHLEN
/* _WINDOWS ̎ MAX_PATH L */
#ifdef	MAX_PATH
#define	MAXPATHLEN	MAX_PATH
#else
#define	MAXPATHLEN	256
#endif
#endif

/* fBNg̍Ō̕ */
#if defined(__MSDOS__) || defined(__WINDOWS__)
#define DIR_CHAR '\\'
#else
#define DIR_CHAR '/'
#endif

// t@Cgq
// count : gqB0͖A1.txtA2.tar.gzȂ
char *get_base_name(char *filename,int count)
{
  char *d0,*d1,*d2;
  int i;

  d0 = filename;
  d1 = strrchr(d0,DIR_CHAR);
  if(d1 == NULL)
    {
#if defined(__MSDOS__) || defined(__WINDOWS__)
      d1 = strrchr(filename,':');
      if(d1 == NULL)
	{
	  d1 = d0;
	}
      else
	{
	  d1++;
	}
#else
      d1 = d0;
#endif
    }
  else
    {
      d1++;
    }
  if(count == 0) d2 = strchr(d1,'.');
  else
    {
      d2 = strchr(d1,'\0');
      while(count > 0)
        {
          if(d2 == d1) { d2 = NULL; count = 0; }
          else
			{
			  d2--;
			  if(*d2 == '.') count--;
			}
        }
    }
  if(d2 == NULL) d2 = strchr(d1,'\0');
  /* d0  d2 ܂ł̊Ԃbasename */
  i = 0;
  while(d0 != d2)
    {
      d2--; i++;
    }
  if(i == 0) return(NULL);
  d1 = xalloc(char,i+1);
  strncpy(d1,d0,i);
  return(d1);
}
#endif
